;(function(){
		var BerbonPlatformJs = {
        createNew : function(){
		var berbonJsObj = {};
		var callbackId = 10; 
		//预览10个
		//0 监听应用消息
		//1 监听系统按键信息
		var callbacks = [];
		/*
		 * @params successF 成功的回调函数
		 * @params failF	失败的回调函数
		 * @params module 调用的模块名
		 * @params	action	要执行的方法名
		 * @params	args	要执行的方法的参数，json格式
		 */
		berbonJsObj.exec = function(successF, failF, module, action, args){
			var callbackIndex = callbackId++;
			if (successF || failF) {
				
				callbacks[callbackIndex] = {
					success : successF,
					fail : failF
				}
			}
			
			window.Android.exec(callbackIndex, module, action, args);
		}
		
		berbonJsObj.setListener = function(listener, event){
			if(event === 'app'){			
				callbacks[0] = listener;
			}else if(event === 'keyEvent'){
				callbacks[1] = listener;
			}
			
			
		}
		
			
		/*
		 * @params	callbackId 需要回调的js的回调函数id号，如果不需要回调为-1
		 * @params	success	boolean值，成功为true，失败为false
		 * @params	status	过滤字段
		 * @params	argString	回调附带的消息描述文本
		 * @params	isKeepCallback 是否保留回调函数，true为保留，false则移除回调函数
		 */
		berbonJsObj.callback = function(callbackId, success, status, argString, isKeepCallback){
			berbonJsObj.handleKeyEvent(callbackId, argString);

			var args = null;
			try{				
				args = JSON.parse(argString);
			}catch(exception){
				console.log(exception);
			}
			
			var callback = callbacks[callbackId];	
			if(callback && callback !== 'undefined' && callbackId === 0){
				callback.apply(null, args);
				return;
			}
			
			if(callbackId < 10){
				return;
			}

			if (callback && callback !== 'undefined') {
				if (success) {
					callback.success && callback.success.apply(null, args);
				} else if (!success) {
					callback.fail && callback.fail.apply(null, args);
				}
				// Clear callback if not expecting any more results
				if (!isKeepCallback) {
					delete callbacks[callbackId];
				}
			}
		}
		
		berbonJsObj.handleKeyEvent = function( callbackId, argStr){
			if(callbackId != 1){
				return;
			}
			//args[0]  key action key_up
			//arg[1] key code
			var callback = callbacks[1];
			var result = false;
			var args = JSON.parse(argStr);
			if(callback && callback !== 'undefined'){
				
				result = callback(args[1]);
			}
			
			window.Android.exec(-1, "System", "keyCodeHandle", '['+args[0]+','+args[1]+','+result+']');
		}
		
		berbonJsObj.log = function(type, msg){
			window.Android.jsLog(type, msg);
		}
		
		//end of class BerbonPlatformJs
		return berbonJsObj;
	}
};

var BerbonJsObj = BerbonPlatformJs.createNew();
window.BerbonJs = {
        exec : BerbonJsObj.exec,
        callback : BerbonJsObj.callback,
        setListener : BerbonJsObj.setListener,
        BerLog : BerbonJsObj.log
};

var doc = document;

var readyEvent = doc.createEvent('Events');
readyEvent.initEvent('BerbonJsReady');
readyEvent.BerbonJs = window.BerbonJs;
doc.dispatchEvent(readyEvent);
})();